#### write_at (1 of 8 overloads)

Write all of the supplied data at the specified offset before returning.

    template<
        typename SyncRandomAccessWriteDevice,
        typename ConstBufferSequence>
    std::size_t write_at(
        SyncRandomAccessWriteDevice & d,
        uint64_t offset,
        const ConstBufferSequence & buffers);

This function is used to write a certain number of bytes of data to a random access device at a specified offset. The call will block until one of the following conditions is true:

- All of the data in the supplied buffers has been written. That is, the bytes transferred is equal to the sum of the buffer sizes.
- An error occurred.

This operation is implemented in terms of zero or more calls to the device's write_some_at function.

###### Parameters

d

  The device to which the data is to be written. The type must support the SyncRandomAccessWriteDevice concept.

offset

  The offset at which the data will be written.

buffers

  One or more buffers containing the data to be written. The sum of the buffer sizes indicates the maximum number of bytes to write to the device.

###### Return Value

The number of bytes transferred.

###### Exceptions

asio::system_error

  Thrown on failure.

###### Example

To write a single data buffer use the `buffer` function as follows:

    asio::write_at(d, 42, asio::buffer(data, size));

See the `buffer` documentation for information on writing multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

###### Remarks

This overload is equivalent to calling:

    asio::write_at(
        d, offset, buffers,
        asio::transfer_all());